//Portdefinition D3
#define DDRX   DDRD
#define PORTX  PORTD
#define PINX   PIND
#define PINXx  PIND3

//Makros
#define SetPinOut  (DDRX  |=  (1<<PINXx))
#define SetPinIn   (DDRX  &= ~(1<<PINXx))
#define SetPinLow  (PORTX &= ~(1<<PINXx))
#define SetPinHigh (PORTX |=  (1<<PINXx))
#define IsPinHigh  (PINX   &  (1<<PINXx))
#define IsPinLow (!(PINX   &  (1<<PINXx)))


int main(void){
//UartPins fungieren als normale Pins mit Makros
UCSR0B = 0b00000000;     // UART deaktivieren
DDRD   = 0b00000010;     // Tx Out, Rx In   
#define SetTXlow  (PORTD &= ~(1<< PIND1))
#define SetTXhigh (PORTD |=  (1<< PIND1))
#define IsRXhigh  (PIND  &   (1<< PIND0))
#define IsRXlow (!(PIND  &   (1<< PIND0)))
                                     
  while(IsRXhigh);                //wait for RX go Low = 1 Incoming data
  while(1){
    SetPinOut;               //RX low = 1 -> set oneWire to output 
    SetPinLow;            //Set oneWire low =1
    SetTXlow;               //Echo low to TX 
    while(IsRXlow);         //Wait RX go high = 0 again  
    SetPinHigh;             //Set OneWire High = 0 for sharper edge //can be skipped?  // input // RX is high (or high again) = 0 end of bit or idle - so listen to data from TRX 
    SetPinIn;                     //and Echo low to TX   |||| rausgerück doppelt: //SetPinHigh;  //Set OneWire pull up   
    while (IsRXhigh){             //while RX high (no incoming bytes)   
      if  (IsPinHigh) SetTXhigh;  //Set TX High = 0
      else            SetTXlow;   //Set TX Low = 1 
    }   
  }    
}
